Require Import bool.
Require Import connectives.
Require Import leibniz.
Parameter nat : Type.
Parameter O : nat.
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Parameter leb : nat -> nat -> bool.bool.
Parameter leb_body : nat -> nat -> bool.bool.
Axiom axiom_leb : forall (n:nat), connectives.equal (nat -> bool.bool) (leb n) (filter_nat_type (nat -> bool.bool) leb_body n).
Definition eq_leb : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (leb n) (filter_nat_type (nat -> bool.bool) leb_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> bool.bool)) (leb n)) (filter_nat_type (nat -> bool.bool) leb_body n)) ((axiom_leb) (n)).
Axiom axiom_leb_body_O : connectives.equal (nat -> bool.bool) (leb_body O) (fun (m:nat) => bool.true).
Definition eq_leb_body_O : leibniz.leibniz (nat -> bool.bool) (leb_body O) (fun (m:nat) => bool.true) := ((((connectives.equal_leibniz) (nat -> bool.bool)) (leb_body O)) (fun (m:nat) => bool.true)) (axiom_leb_body_O).
