Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import nat.
Parameter gcd_aux : nat.nat -> nat.nat -> nat.nat -> nat.nat.
Parameter gcd_aux_body : nat.nat -> nat.nat -> nat.nat -> nat.nat.
Axiom axiom_gcd_aux : forall (p:nat.nat), connectives.equal (nat.nat -> nat.nat -> nat.nat) (gcd_aux p) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p).
Definition eq_gcd_aux : forall (p:nat.nat), leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (gcd_aux p) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p) := fun (p:nat.nat) => ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux p)) (nat.filter_nat_type (nat.nat -> nat.nat -> nat.nat) gcd_aux_body p)) ((axiom_gcd_aux) (p)).
Axiom axiom_gcd_aux_body_O : connectives.equal (nat.nat -> nat.nat -> nat.nat) (gcd_aux_body nat.O) (fun (m:nat.nat) => fun (n:nat.nat) => m).
Definition eq_gcd_aux_body_O : leibniz.leibniz (nat.nat -> nat.nat -> nat.nat) (gcd_aux_body nat.O) (fun (m:nat.nat) => fun (n:nat.nat) => m) := ((((connectives.equal_leibniz) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux_body nat.O)) (fun (m:nat.nat) => fun (n:nat.nat) => m)) (axiom_gcd_aux_body_O).
Definition gcd : nat.nat -> nat.nat -> nat.nat := fun (n:nat.nat) => fun (m:nat.nat) => bool.match_bool_type (nat.nat) (gcd_aux n m n) (gcd_aux m n m) (nat.leb n m).
Definition gcd_O_l : forall (m:nat.nat), logic.eq (nat.nat) (gcd nat.O m) m := fun (m:nat.nat) => (((((bool.eq_match_bool_type_true) (nat.nat)) (m)) (gcd_aux m nat.O m)) (fun (y:nat.nat) => logic.eq (nat.nat) (gcd nat.O m) y)) (((nat.eq_leb_body_O) (fun (y:(nat.nat -> bool.bool)) => logic.eq (nat.nat) (gcd nat.O m) (bool.match_bool_type (nat.nat) m (gcd_aux m nat.O m) (y m)))) (((((nat.eq_filter_nat_type_O) (nat.nat -> bool.bool)) (nat.leb_body)) (fun (y:(nat.nat -> bool.bool)) => logic.eq (nat.nat) (gcd nat.O m) (bool.match_bool_type (nat.nat) m (gcd_aux m nat.O m) (y m)))) ((((nat.eq_leb) (nat.O)) (fun (y:(nat.nat -> bool.bool)) => logic.eq (nat.nat) (gcd nat.O m) (bool.match_bool_type (nat.nat) m (gcd_aux m nat.O m) (y m)))) (((eq_gcd_aux_body_O) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) (gcd nat.O m) (bool.match_bool_type (nat.nat) (y m nat.O) (gcd_aux m nat.O m) (nat.leb nat.O m)))) (((((nat.eq_filter_nat_type_O) (nat.nat -> nat.nat -> nat.nat)) (gcd_aux_body)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) (gcd nat.O m) (bool.match_bool_type (nat.nat) (y m nat.O) (gcd_aux m nat.O m) (nat.leb nat.O m)))) ((((eq_gcd_aux) (nat.O)) (fun (y:(nat.nat -> nat.nat -> nat.nat)) => logic.eq (nat.nat) (gcd nat.O m) (bool.match_bool_type (nat.nat) (y m nat.O) (gcd_aux m nat.O m) (nat.leb nat.O m)))) (((logic.refl) (nat.nat)) (gcd nat.O m)))))))).
